Bug 731980

Summary: Review Request: python-novaclient - Python API and CLI for OpenStack Nova
Product: [Fedora] Fedora Reporter: Mark McLoughlin <markmc>
Component: Package ReviewAssignee: Mark McLoughlin <markmc>
Status: CLOSED NEXTRELEASE QA Contact: Fedora Extras Quality Assurance <extras-qa>
Severity: medium Docs Contact:
Priority: medium    
Version: rawhideCC: bloch, clalance, matt_domsch, notting, package-review
Target Milestone: ---Flags: clalance: fedora‑review+
limburgher: fedora‑cvs+
Target Release: ---   
Hardware: All   
OS: Linux   
Whiteboard:
Fixed In Version: Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of: Environment:
Last Closed: 2011-08-23 03:34:17 EDT Type: ---
Regression: --- Mount Type: ---
Documentation: --- CRM:
Verified Versions: Category: ---
oVirt Team: --- RHEL 7.3 requirements from Atomic Host:
Bug Depends On:    
Bug Blocks: 707199    

Description Mark McLoughlin 2011-08-19 07:04:55 EDT
This is a python API and command line client for OpenStack's Compute Service (Nova) API. There are two sub-packages - python-novaclient and openstack-novaclient-doc - as well as the main package.

It is required by openstack-nova, see bug #707199

Spec URL: https://raw.github.com/markmc/openstack-fedora-specs/06604ba9/SPECS/openstack-novaclient.spec
SRPM URL: http://koji.fedoraproject.org/koji/getfile?taskID=3285697&name=openstack-novaclient-2.6.1-0.2.83bzr.fc16.src.rpm
Scratch Koji Build URL: http://koji.fedoraproject.org/koji/taskinfo?taskID=3285696
Fedora 16 yum repo URL: http://repos.fedorapeople.org/repos/markmc/openstack/fedora-openstack.repo

Description:
This is a client for the OpenStack Nova API. There's a Python API (the
novaclient module), and a command-line script (nova). Each implements 100% of
the OpenStack Nova API.
Comment 1 Chris Lalancette 2011-08-19 11:42:48 EDT
I'll review this one.
Comment 2 Chris Lalancette 2011-08-19 13:18:44 EDT
Mark, from a high-level perspective, why have the 2 subpackages (openstack-novaclient and python-novaclient)?  Since the main package only contains a single executable that is python anyway, what about mashing the two together into just python-novaclient?  This has the added benefit of matching the upstream tarball.

rpmlint output:

[clalance@localhost SPECS]$ rpmlint /home/clalance/rpmbuild/SRPMS/openstack-novaclient-2.6.1-0.2.83bzr.fc14.src.rpm
1 packages and 0 specfiles checked; 0 errors, 0 warnings.
[clalance@localhost SPECS]$ rpmlint /home/clalance/rpmbuild/RPMS/noarch/openstack-novaclient-2.6.1-0.2.83bzr.fc14.noarch.rpm
openstack-novaclient.noarch: W: no-documentation
openstack-novaclient.noarch: W: no-manual-page-for-binary nova
1 packages and 0 specfiles checked; 0 errors, 2 warnings.
[clalance@localhost SPECS]$ rpmlint /home/clalance/rpmbuild/RPMS/noarch/python-novaclient-2.6.1-0.2.83bzr.fc14.noarch.rpm
python-novaclient.noarch: E: explicit-lib-dependency python-httplib2
1 packages and 0 specfiles checked; 1 errors, 0 warnings.
[clalance@localhost SPECS]$ rpmlint /home/clalance/rpmbuild/RPMS/noarch/openstack-novaclient-doc-2.6.1-0.2.83bzr.fc14.noarch.rpm
1 packages and 0 specfiles checked; 0 errors, 0 warnings.

The error in python is a false-positive, and the two warnings are unfortunate but not showstoppers.

===========================================================================

In the description, there is a bit of a fragment:

This package contains command-line script.

Maybe should be:

This package contains the command-line script.

(but that is minor)

===========================================================================

Checklist

[  OK  ] MUST: rpmlint must be run on every package
[  OK  ] MUST: The package must be named according to the Package Naming 
         Guidelines
[  OK  ] MUST: The spec file name must match the base package %{name} [...]
[  OK  ] MUST: The package must be licensed with a Fedora approved license
         and meet the Licensing Guidelines
[  OK  ] MUST: The License field in the package spec file must match the 
         actual license
[  OK  ] MUST: If (and only if) the source package includes the text of the 
         license(s) in its own file, then that file, containing the text of 
         the license(s) for the package must be included in %doc - clalance: while the LICENSE file is in the git checkout, it does not make it into the upstream tarball, so this is OK.
[  OK  ] MUST: Packages must not contain pre-built binaries or libraries
[  OK  ] MUST: The spec file must be written in American English.
[  OK  ] MUST: The spec file for the package must be legible.
[  OK  ] MUST: The sources used to build the package must match the upstream 
         source, as provided in the spec URL. Reviewers should use md5sum for 
         this task. If no upstream URL can be specified for this package, 
         please see the Source URL Guidelines for how to deal with this.
[  OK  ] MUST: The package MUST successfully compile and build into binary 
         rpms on at least one primary architecture
[  N/A ] MUST: If the package does not successfully compile, build or work on 
         an architecture, then those architectures should be listed in the 
         spec in ExcludeArch. Each architecture listed in ExcludeArch MUST 
         have a bug filed in bugzilla, describing the reason that the package 
         does not compile/build/work on that architecture. The bug number MUST 
         be placed in a comment, next to the corresponding ExcludeArch line
[  OK  ] MUST: Packages must not have a BuildRoot tag as of Fedora-10
[  ??  ] MUST: All build dependencies must be listed in BuildRequires, except 
         for any that are listed in the exceptions section of the Packaging 
         Guidelines ; inclusion of those as BuildRequires is optional. Apply 
         common sense. - clalance: Mark, is python-devel really a BuildRequires?  A quick look through the source seems to indicate that it is pure python, but maybe I am missing something.
[  OK  ] MUST: Large documentation files must go in a -doc subpackage. (The 
         definition of large is left up to the packager's best judgement, but 
         is not restricted to size. Large can refer to either size or 
         quantity).
[  OK  ] MUST: If a package includes something as %doc, it must not affect the 
         runtime of the application. To summarize: If it is in %doc, the 
         program must run properly if it is not present.
[  N/A ] MUST: The spec file MUST handle locales properly. This is done by 
         using the %find_lang macro. Using %{_datadir}/locale/* is strictly 
         forbidden
[  N/A ] MUST: Every binary RPM package (or subpackage) which stores shared 
         library files (not just symlinks) in any of the dynamic linker's 
         default paths, must call ldconfig in %post and %postun.
[  N/A  ] MUST: If the package is designed to be relocatable, the packager must 
         state this fact in the request for review, along with the 
         rationalization for relocation of that specific package. Without 
         this, use of Prefix: /usr is considered a blocker.
[      ] MUST: A package must own all directories that it creates. If it does 
         not create a directory that it uses, then it should require a package 
         which does create that directory.
[      ] MUST: A package must not contain any duplicate files in the %files 
         listing.
[      ] MUST: Permissions on files must be set properly. Executables should 
         be set with executable permissions, for example.
[  OK  ] MUST: Packages must not have a %clean section.
[  OK  ] MUST: Each package must consistently use macros.
[  OK  ] MUST: The package must contain code, or permissable content.
[  N/A ] MUST: Header files must be in a -devel package.
[  N/A ] MUST: Static libraries must be in a -static package.
[  N/A ] MUST: Packages containing pkgconfig(.pc) files must 'Requires: 
         pkgconfig' (for directory ownership and usability).
[  N/A ] MUST: If a package contains library files with a suffix (e.g. 
         libfoo.so.1.1), then library files that end in .so (without suffix) 
         must go in a -devel package.
[  N/A ] MUST: In the vast majority of cases, devel packages must require the 
         base package using a fully versioned dependency: Requires: %{name} =
         %{version}-%{release}
[  N/A ] MUST: Packages must NOT contain any .la libtool archives, these must 
         be removed in the spec if they are built.
[  N/A ] MUST: Packages containing GUI applications must include a
         %{name}.desktop file, and that file must be properly installed with 
         desktop-file-install in the %install section. If you feel that your 
         packaged GUI application does not need a .desktop file, you must put 
         a comment in the spec file with your explanation.
[  OK  ] MUST: Packages must not own files or directories already owned by 
         other packages. The rule of thumb here is that the first package to 
         be installed should own the files or directories that other packages 
         may rely upon. This means, for example, that no package in Fedora 
         should ever share ownership with any of the files or directories 
         owned by the filesystem or man package. If you feel that you have a 
         good reason to own a file or directory that another package owns, 
         then please present that at package review time.
[  OK  ] MUST: All filenames in rpm packages must be valid UTF-8.

============================================================================

Overall, the outstanding questions are:
1)  Why the split between openstack-novaclient and python-novaclient?
2)  Minor nit in the summary.
3)  Is python-devel really a BuildRequires?

It looks fine otherwise.
Comment 3 Mark McLoughlin 2011-08-22 08:25:45 EDT
Thanks Chris!

(In reply to comment #2)

> Overall, the outstanding questions are:
> 1)  Why the split between openstack-novaclient and python-novaclient?

Yeah, I think that's a fair point - I've removed the split now

> 2)  Minor nit in the summary.

Fixed

> 3)  Is python-devel really a BuildRequires?

The guidelines suggest that it's needed:

http://fedoraproject.org/wiki/Packaging:Python

But I've looked closely, and I can't see any reason for it - all we need is python-setuptools


New version:

Spec URL: https://raw.github.com/markmc/openstack-fedora-specs/ce087581/SPECS/python-novaclient.spec
SRPM URL: http://koji.fedoraproject.org/koji/getfile?taskID=3291190&name=openstack-nova-2011.3-0.2.1449bzr.fc16.src.rpm
Scratch Koji Build URL: http://koji.fedoraproject.org/koji/taskinfo?taskID=3291189
Fedora 16 yum repo URL: http://repos.fedorapeople.org/repos/markmc/openstack/fedora-openstack.repo
Comment 4 Chris Lalancette 2011-08-22 10:56:33 EDT
> New version:
> 
> Spec URL:
> https://raw.github.com/markmc/openstack-fedora-specs/ce087581/SPECS/python-novaclient.spec

There is one more minor nit in that SPEC, in that you can now drop the -n python-novaclient-%{version} from %setup.  But I won't hold it up for that, it would just be nice to fix when you commit.

APPROVED
Comment 5 Mark McLoughlin 2011-08-22 11:12:26 EDT
Thanks Chris!

New Package SCM Request
=======================
Package Name: python-novaclient
Short Description: Python API and CLI for OpenStack Nova
Owners: markmc
Branches: f16
InitialCC:
Comment 6 Jon Ciesla 2011-08-22 14:32:25 EDT
Git done (by process-git-requests).
Comment 7 Mark McLoughlin 2011-08-23 03:34:17 EDT
Built now in rawhide and f16
Comment 8 Matt Domsch 2011-08-29 14:14:15 EDT
Mark, can you branch for el6?  It needs

-BuildRequires:    python-sphinx
+%{?fedora:BuildRequires:    python-sphinx >= 1.0}
+%{?el6:BuildRequires:    python-sphinx10}

like all the other packages. After that, it still fails building docs, but the rest builds.
Comment 9 Mark McLoughlin 2011-08-29 17:01:48 EDT
(In reply to comment #8)
> Mark, can you branch for el6?

Yep, feel free

> It needs
> 
> -BuildRequires:    python-sphinx
> +%{?fedora:BuildRequires:    python-sphinx >= 1.0}
> +%{?el6:BuildRequires:    python-sphinx10}
> 
> like all the other packages. After that, it still fails building docs, but the
> rest builds.

My first instinct would be to not clutter the the specs with conditionals, but instead just make the change on the epel6 branch and then git merge changes from f16 later as needed
Comment 10 Matt Domsch 2011-08-30 11:14:58 EDT
Package Change Request
======================
Package Name: python-novaclient
New Branches: el6
Owners: markmc
Comment 11 Jon Ciesla 2011-08-30 11:35:35 EDT
Git done (by process-git-requests).